package edu.chl.hajo.monopoly;

import edu.chl.hajo.monopoly.core.Board;
import edu.chl.hajo.monopoly.core.Dices;
import edu.chl.hajo.monopoly.core.Monopoly;
import edu.chl.hajo.monopoly.core.Piece;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.Space;
import edu.chl.hajo.monopoly.core.Street;
import edu.chl.hajo.monopoly.view.MainWindow;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.SwingUtilities;

/**

 @author hajo
 */
public class Main {

    public static void main(String[] args) {

         try {
            // TODO Fix file handling. This is copy paste from test
            String[] spaceNames = ("go,1:1,cc1,1:2,income,train1,2:1,chance1,2:2,2:3,"
                    + "jail,3:1,electric,3:2,3:3,train2,4:1,cc2,4:2,4:3,"
                    + "parking,5:1,chance2,5:2,5:3,train3,6:1,6:2,water,6:3,"
                    + "gotojail,7:1,7:2,cc3,7:3,train4,chance3,8:1,luxury,8:2").split(",");
            
            List<Space> spaces = getSpaces(spaceNames);
            Board board = new Board(spaces);
            List<Player> players = getPlayers(PLAYER_NAMES);
            Dices dices = new Dices();
            Monopoly monopoly = new Monopoly(players, board, dices);          
            // Thsi is the way to start a Swing application
            SwingUtilities.invokeAndWait(() -> {
                MainWindow mainWindow = new MainWindow(monopoly);
                mainWindow.setVisible(true);
            });
            // GUI must be up before this
            monopoly.init();
        } catch (InterruptedException | InvocationTargetException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static List<Space> getSpaces(String[] names) {
        List<Space> sps = new ArrayList<>();
        for (String name : names) {
            // Name starts with number, a street
            if ("123456789".indexOf(name.charAt(0)) >= 0) {
                sps.add(new Street(name, Board.BASIC_RENT));
            } else {
                sps.add(new Space(name));
            }
        }
        return sps;
    }

    // This will later come from GUI
    public static final String[] PLAYER_NAMES = "olle,fia,allan,siv".split(",");

    public static List<Player> getPlayers(String[] names) {
        List<Player> sps = new ArrayList<>();
        int i = 0;
        for (String name : names) {
            sps.add(new Player(name, Piece.values()[i], Monopoly.BALANCE));
            i++;
        }
        return sps;
    }

}
