package edu.chl.hajo.monopoly.view;

import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.Space;
import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.event.IEventHandler;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JPanel;

/**

 @author hajo
 */
public class SpacePanel extends JPanel implements IEventHandler {

    private final String name;
    private final List<Player> visitors = new ArrayList<>();
    private final Font font = new Font("SansSerif", Font.BOLD, 16);
    
    public SpacePanel(String name) {
        this.name = name;
        initGUI();
        initEvent();
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2 = (Graphics2D) g;
        g.drawString(name, 2, 10);
        
        g.setFont(font);
        int i = 5;
        for (Player visitor : visitors) {
            g.drawString(visitor.getName(), 2, i * 10);
            i++;
        }

    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.PLAYER_POSITION) {
            Player p = (Player) evt.getValue();
            if (p.getPosition().getName().equals(name)) {
                visitors.add(p);
            } else {
                visitors.remove(p);
            }
        }
        repaint();
    }

    private void initGUI() {
        this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
    }

    private void initEvent() {
        EventBus.BUS.register(this);
    }
}
