package mvc;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * The only panel. GUI should be composed of (many small) panels.
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class MyPanel extends JPanel implements ActionListener, IEventHandler{

    public MyPanel(){
        init();
        EventBus.INSTANCE.register(this);  // register as an observer
    }
 
    /*
     * This method is called when model updates
     */
    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.I_CHANGED) {
            Integer i = (Integer) evt.getValue();
            in.setText(String.valueOf(i));
        }else if (evt.getTag() == Event.Tag.RESULT_CHANGED){ 
        	Integer i = (Integer) evt.getValue();
        	 out.setText(String.valueOf(i));
        }else if (evt.getTag() == Event.Tag.I_EVEN){
            out.setBackground(Color.RED);
        }else if (evt.getTag() == Event.Tag.I_ODD){
            out.setBackground(Color.GREEN);
        }else{
            throw new IllegalArgumentException("Bad event");
        }
        // repaint(); // Possible  
    }

    /*
     * Calls from GUI to model goes this way
     */
    @Override
    public void actionPerformed(ActionEvent e) {
       if( e.getSource() == button){
           int i = Integer.parseInt(in.getText());
           Model.getInstance().setI(i);
           Model.getInstance().doSomeCalcualtions();
       }
       // Functional approach
       //int i = Model.getInstance().doSomeCalcualtions2();
       //in.setText(String.valueOf(i));
        
    }

    // Construction code (separate out) -----------------------
    
    private JTextField out = new JTextField();
    private JTextField in = new JTextField();
    private JButton button = new JButton("DoIT");
    
    private void init() {
        out.setColumns(10);
        in.setColumns(10);
        this.add(in);
        this.add(out);
        this.add(button); 
        button.addActionListener(this);
    }
    
}
