package chl.hajo.gdxdemo.core;

import java.util.List;

/**

 @author hajo
 */
public class Model {

    private final int maxWidth;
    private final int maxHeight;
    private final Bucket bucket;
    private final Rain rain;

    public Model(int maxWidth, int maxHeight) {
        this.maxWidth = maxWidth;
        this.maxHeight = maxHeight;
        this.bucket = new Bucket(maxWidth);
        this.rain = new Rain(maxWidth, maxHeight, 10, 64);
    }

    public enum Dir {

        LEFT,
        RIGHT
    }

    public Bucket getBucket() {
        return bucket;
    }

    public void moveBucket(Dir dir, float dist) {
        if (dir == Dir.LEFT) {
            bucket.moveLeft(dist);
        } else {
            bucket.moveRight(dist);
        }
    }

    public void spawnRaindrop() {
        rain.spawnRaindrop();
    }

    public List<RainDrop> getRainDrops() {
        return rain.getRainDrops();
    }

    public int getMaxRainDrops() {
        return rain.getMaxDrops();
    }

}
